#include <iostream>
using namespace std;
#include <mpi.h>

/*  ReadId : Abfrage und Broadcast einer Integerzahl */

int ReadIn()
{
 MPI_Barrier(MPI_COMM_WORLD);
 int myrank, id;

 MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
 if (myrank==0) {
   cout << "\n\n Which process do you want to debug ? \n";
   cin >> id;
 }
 MPI_Bcast(&id, 1, MPI_INT, 0, MPI_COMM_WORLD);

 return id;
}


void DebugD(const int n, const double x[])
{
 int numprocs;		/*  # processes    */
 int myrank;     	/*  my rank number */
 MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
 MPI_Comm_size(MPI_COMM_WORLD, &numprocs);

 int readid = ReadIn();				/* Read  readid    */

 while ( (0 <= readid) && (readid < numprocs) )
 {
   if (myrank==readid) {
     cout << "\n\n process " << readid << endl;
     for (int i=0; i<n; ++i)  cout << "   " << x[i];
     cout << endl;
     fflush(stdout);
   }

   readid = ReadIn();			/* Read  readid    */
 }

}
