#ifndef HEADER_DEBUG
#define HEADER_DEBUG
#include <mpi.h>
/**
 * Reads one integer from the terminal and broadcasts it to all processes.
 * @return	a number read by root process 0  which is broadcasted to all processes
*/

int ReadIn();

/**
 * Reads a integer number with the rank of a process from the terminal and
 * writes the elements of vector @p x of this process onto the terminal.
 * This will be repeated while rank number is valid, i.e., -1 stops the loop.
 * @param[in] n		number of elements of vector @p x (of my process)
 * @param[in] x		local vector (double) on my process
*/

void DebugD(const int n, const double x[]);


#endif
