/*
	Compute scalar product of two vectors

	IN:	n	length of the vectors
		x,y 	vectors
	OUT:	scalar	scalar product
*/
#include <mpi.h>
#include "vdop.h"

double skalar(const int n, const double x[], const double y[], const MPI::Intracomm& icomm)
{
  const double s = dscapr(n,x,y);                // call sequential inner product
        double sg;
  icomm.Allreduce(&s,&sg,1,MPI::DOUBLE,MPI::SUM);

  return(sg);
}



