#include <iostream>
#include <cstdlib>
using namespace std;
#include <mpi.h>

const int TAG1 = 1;
const int TAG2 = 2;

void Send_ProcD(const int to, const int nin, const double xin[], const MPI::Intracomm &icomm)
{
//   cout << icomm.Get_rank() << "  -->  " << to << "  (length " << nin << ")\n";

    //icomm.Ssend(&nin, 1, MPI::INT, to, TAG1);
    icomm.Isend(&nin, 1, MPI::INT, to, TAG1);
//   int info=stat.Get_error();
//   if (info!=MPI::SUCCESS)
//   { cout << "\n Send_ProcD : " << info << endl; exit(-3); }

    if (nin > 0) {
        //icomm.Ssend(xin, nin, MPI::DOUBLE, to, TAG2);
        icomm.Isend(xin, nin, MPI::DOUBLE, to, TAG2);
    }

    return;
}


// no check for length of message anymore!
void Recv_ProcD(const int from, int &nout, double xout[], const int maxbuf,
                const MPI::Intracomm &icomm)
{
//   cout << icomm.Get_rank() << "  <--  " << from << "\n";
    MPI::Status stat;

    //icomm.Recv(&nout, 1, MPI::INT, from, TAG1, stat);
    MPI::Request rq = icomm.Irecv(&nout, 1, MPI::INT, from, TAG1);
    int info = stat.Get_error();
    MPI::Request::Waitall(1, &rq);

    if (info != MPI::SUCCESS) {
        cout << "\n Recv_ProcD : " << info << endl;
        exit(-3);
    }

    if (nout > maxbuf) {
        cout << "\n Recv_ProcD : maxbuf (= " << maxbuf << ") is too small vs. "
             << nout << endl;
        exit(-3);
    }

    if (nout > 0) {
        icomm.Recv(xout, nout, MPI::DOUBLE, from, TAG2, stat);
//     int info=stat.Get_error();
    }

    return;
}



void ExchangeD(const int yourid, const int nin, const double xin[],
               int &nout, double xout[], const int maxbuf, const MPI::Intracomm &icomm)
{
    if (yourid < 0) { nout = -1; return; }

    MPI::Request rq;

    if (yourid >= 0) {
        rq = icomm.Irecv(xout, nin, MPI::DOUBLE, yourid, TAG2);
        icomm.Isend(xin, nin, MPI::DOUBLE, yourid, TAG2);
    }

    MPI::Request::Waitall(1, &rq);

    return;
}


