//		MPI code in C++.
//		See [Gropp/Lusk/Skjellum, "Using MPI", p.33/41 etc.]
//		and  /opt/mpich/include/mpi2c++/comm.h  for details

#include <iostream>
using namespace std;
#include <mpi.h>
#include "dexx.h"

int main(int argc,char* argv[])
{
    MPI::Init(argc,argv);
    MPI::Intracomm icomm(MPI::COMM_WORLD);
    const int numprocs = icomm.Get_size();
    const int myrank   = icomm.Get_rank();

    if (myrank == 0)
    { cout << "\n There are " << numprocs << " processes running.\n \n"; }

    const int maxbuf = 100;
    double    x[maxbuf], y[maxbuf];

    const int nin  = min(20,maxbuf);
          int nout;
    double one = myrank*10+5.0;

    for (int i=0; i<nin; ++i)  x[i] = one;

    const int yourid = myrank ^ 1;	// find the partner for communication
    ExchangeD(yourid, nin, x, nout, y, maxbuf, icomm);

    for(int i=0; i<nout; ++i)
	{
	  cout << endl << i << "  " << myrank << " : " << nout << "  "
	       << y[i] << endl;
	}

    MPI::Finalize();
    return 0;
}


