//		MPI code in C++.
//		See [Gropp/Lusk/Skjellum, "Using MPI", p.33/41 etc.]
//		and  /opt/mpich/include/mpi2c++/comm.h  for details

#include <iostream>
using namespace std;
#include <mpi.h>
#include "debugd.h"
#include "pivot.h"

int main(int argc,char* argv[])
{
    MPI::Init(argc,argv);

    MPI::Intracomm icomm(MPI::COMM_WORLD);

    const int numprocs = icomm.Get_size();
    const int myrank   = icomm.Get_rank();

    if (myrank == 0)
    {
       cout << "\n There are " << numprocs << " processes running.\n \n";
    }

    if (myrank == 0) cout << endl;

    const int N=10;
    double    x[N];

    for (int i=0; i<N; ++i)  x[i] = (i+1.0)*(myrank+1);

    DebugD(N,x);
    if (myrank == 0) cout << "\n\nStart Pivoting.\n\n" << endl;
    PivotD(N,x);
    DebugD(N,x);

    MPI::Finalize();

    return 0;
}
