#!/bin/sh -f
#$ -V
#$ -cwd
#$ -j y
#$ -pe mpi 4

TMPDIR=.
# write ranks and slots
cluster=0;
while read line; do
# map process ranks to the cluster nodes and slots: special for 4x4 processes on 2x2 compute nodes
for i in 0 1 2 3; do
let "rank = (cluster/2)*8 + (cluster%2)*2 + ($i/2*4)+ ($i%2)"
echo "rank" $rank"="$line "slot="$i
done
let "cluster += 1"
done < $TMPDIR/machines > $TMPDIR/rankfile
cat $TMPDIR/rankfile

mpirun --np 16 --hostfile $TMPDIR/machines --rankfile $TMPDIR/rankfile jacpar/main.GCC_
mpirun --np 16 --hostfile $TMPDIR/machines --rankfile $TMPDIR/rankfile first/main.GCC_
