#include <iostream>
using namespace std;
#include <mpi.h>

/*  ReadId : Abfrage und Broadcast einer Integerzahl */

int ReadIn()
{
 const MPI::Intracomm& icomm = MPI::COMM_WORLD;
 icomm.Barrier();
 const int myrank = icomm.Get_rank();
       int id;

 if (myrank==0) {
   cout << "\n\n Which process do you want to debug ? \n";
   cin >> id;
 }
 icomm.Bcast(&id, 1, MPI::INT, 0);

 return id;
}


void DebugD(const int n, const double x[])
{
 const MPI::Intracomm& icomm = MPI::COMM_WORLD;
 const int numprocs = icomm.Get_size();		/*  # processes    */
 const int myrank   = icomm.Get_rank();		/*  my rank number */

 int readid = ReadIn();				/* Read  readid    */

 while ( (0 <= readid) && (readid < numprocs) )
 {
   if (myrank==readid) {
     cout << "\n\n process " << readid << endl;
     for (int i=0; i<n; ++i)  cout << "   " << x[i];
     cout << endl;
     fflush(stdout);
   }

   readid = ReadIn();			/* Read  readid    */
 }

}

// void DebugI(n,x)
//
// int    n, x[];
// {
//  int numprocs, myid, i,j, readid;
//
//  MPI_Comm_size(MPI_COMM_WORLD,&numprocs);	/*  # processes    */
//  MPI_Comm_rank(MPI_COMM_WORLD,&myid);		/*  my rank number */
//
//  ReadIn(myid,&readid);				/* Read  readid    */
//
//  while ( (0 <= readid) && (readid < numprocs) )
//  {
//    if (myid==readid) {
//      printf("\n\n process %d \n",readid);
// /*     for (i=0; i<n; i++)  printf("  %i ",x[i]); */
//      for (j=0; j<n/10; j++)
//      {
//        printf("%u : ",j*10);
//        for (i=0;i<10;i++) printf("  %i ",x[10*j+i]);
//        printf("\n");
//      }
//      printf("%u : ",j*10);
//      for (i=j*10;i<n;i++) printf("  %i ",x[i]);
//
//      printf("\n");
//      fflush(stdout);
//    }
//
//    ReadIn(myid,&readid);			/* Read  readid    */
//  }
//
// }
