#include <iostream>
#include <omp.h>                // OpenMP
using namespace std;
#include "help.h"

int status_threads()
{
    int nthreads = -1;

    #pragma omp parallel default(none) shared(nthreads,cout)
    {
        int th_id = omp_get_thread_num();                 // OpenMP
        #pragma omp single
        {
            nthreads = omp_get_num_threads();             // OpenMP
        } 
        #pragma omp critical
        {
            cout << "C++: Hello World from thread " << th_id << "  out of " << nthreads << endl;
        }
    }
    return nthreads;
}

// ----------------- INTEL example ---------------------------------------------------

std::string get_device_name()
{
 #ifdef __MIC__
  std::string device_name = "MIC ";
#else
  std::string device_name = "HOST";
#endif // __MIC__

 return device_name;
}


void testThreadCount()
{
#ifdef __INTELOFFLOAD
  int mic_rank = _Offload_get_device_number();
  int num_mics = _Offload_number_of_devices();
#else
  int mic_rank = -1;
  int num_mics = 1;
#endif
   #pragma omp parallel
   {
     int tid = omp_get_thread_num();
     #pragma omp critical
     {
       std::cout << "Hello by thread id: " << tid << " --> " << get_device_name() << ": " << mic_rank << " / " << num_mics << std::endl;
     }
     #pragma omp barrier
     #pragma omp single
     {
       int thread_count = omp_get_num_threads();
       #pragma omp critical
       {
         std::cout << "Thread count: " << thread_count << std::endl;
         std::cout << "======================================" << std::endl;
       }
     }
  }
}


