// idea: originates from Ruetsch/Oster: Getting Started with CUDA
// b:=a on accel.
// incr. data in b on accel.

#include <assert.h>

void inc_array(double *a, const int N)
{
  int idx;
#pragma acc parallel loop present(a)
  for ( idx=0; idx<N; ++idx )
  {
    a[idx] = a[idx] + 1.0;
  }
  return;
}


//  main function on host
int main(void)
{
 const int N = 140000;
 double a[N], b[N];
 int i;
	   
// init  "a" on  host 
 for (i=0; i<N; ++i) a[i] = 100.0 + i;

// copy data "a":  host --> accel
#pragma acc data  copyin(a) copyout(b)
 {
#pragma acc parallel loop
   for (i=0; i<N; ++i)
     b[i] = a[i];
   
   inc_array(b, N);
 }  //  data "b":  host <-- accel

// Check correctness
 for (i=0; i< N; i++) assert( a[i] == b[i]-1.0 );

 return 0;
}
