#include <iostream>
using namespace std;

#include "vdop.h"

void vddiv(const int n,  float x[], const int ix,
           const float y[], const int iy,
           const float z[], const int iz)
{
#pragma omp parallel for default(none) shared(x,y,z)
#pragma acc kernels loop independent pcopy(x[0:n]) pcopyin(y[0:n],z[0:n])        // correct even for x==y
    for (int k = 0; k < n; ++k) {
        x[k * ix] = y[k * iy] / z[k * iz];
    }
    return;
}


void vdaxpy(const int n, float x[], const float y[],
            const float a,   const float z[] )
{
#pragma omp parallel for default(none) shared(x,y,z)
//#pragma acc parallel loop pcopyout(x[0:n]) pcopyin(y[0:n],z[0:n])   // incorrect if x==y
#pragma acc kernels loop independent pcopy(x[0:n]) pcopyin(y[0:n],z[0:n])        // correct even for x==y
    for (int k = 0; k < n; ++k) {
        x[k] = y[k] + a * z[k];
    }
    return;
}


/******************************************************************************/
float dscapr(const int n, const float x[], const float y[])
{
    float    s = 0.0;

#pragma omp parallel for default(none) shared(x,y) reduction(+:s)
#pragma acc kernels loop pcopyin(x[0:n],y[0:n]) reduction(+:s)
    for (int k = 0; k < n; ++k) {
        s += x[k] * y[k];
    }

    return s;
}

