/*
	Copy the accumulated diagonal of sk into d

	IN:	nx, ny	number of points in x/y-direction
		sk	matrix
		id	crs pointer of sk (points at last element in row)
	OUT:	d	diagonal of sk
*/
#include <mpi.h>
#include "vecaccu.h"
#include "debugd.h"
#include "getmatrix.h"


void AccuDiag(const int nnode, const int id[], const int ik[], const double sk[], double d[],
              const int nx, const int ny, const int neigh[], const int color, const MPI::Intracomm &icomm)
{
    GetDiag(nnode, id, ik, sk, d);
    VecAccu(nx, ny, d, neigh, color, icomm);
    //DebugD(nd,d);
    return;
}

