% Results of scaling tests for scalar product
% Oct 21, 2016
% N = 100000000


% Hardware: 143.50.47.112
%           2 x ( Six-Core AMD Opteron(tm) Processor 2427 [6 Cores, 6x0.5 MB Cache])
%           28 GB memory
clear; clc; clf
threads = [1 2 4 6 8 10 12];

%% A)  s = sum x[i]*y[i]

ta = [0.29,  0.18, 0.21, 0.19, 0.18, 0,18, 0.17];

%% B)  s = sum exp ( log(x[i])+log(y[i]) )

tb = [13.0, 6.7, 3.4, 2.3, 1.7, 1.4, 1.2];

%% Plot run time
plot(threads,ta,'-bs',threads,tb,'-r*')
xlabel('#threads')
ylabel('sec.')
title('runtime on 2x Opteron [2x6 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')


%% Plot speedup
plot(threads,ta(1)./ta,'-bs',threads,tb(1)./tb,'-r*')
xlabel('#threads')
ylabel('speedup')
title('speedup on 2x Opteron [2x6 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')


%% Plot efficency
plot(threads,ta(1)./ta./threads,'-bs',threads,tb(1)./tb./threads,'-r*')
xlabel('#threads')
ylabel('efficency')
title('efficency on 2x Opteron [2x6 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')
