% Results of scaling tests for scalar product
% Oct 7, 2016
% N = 100000000


% Hardware: 143.50.47.112
%           Intel(R) Xeon(R) CPU E5-2660 v2 @ 2.20GHz   (10 cores, 25MB L2 cache)
%           64 GB memory
clear; clc; clf
threads = [1 2 4 8 10 16 20];

%% A)  s = sum x[i]*y[i]

ta = [0.15,  0.075, 0.042, 0.037, 0.042, 0.036, 0.038];

%% B)  s = sum exp ( log(x[i])+log(y[i]) )

tb = [10.0, 4.3, 2.3, 1.1, 1.1, 0.82, 0.71];

%% Plot run time
plot(threads,ta,'-bs',threads,tb,'-r*')
xlabel('#threads')
ylabel('sec.')
title('runtime on E5-2660 [10 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')


%% Plot speedup
plot(threads,ta(1)./ta,'-bs',threads,tb(1)./tb,'-r*')
xlabel('#threads')
ylabel('speedup')
title('speedup on E5-2660 [10 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')


%% Plot efficency
plot(threads,ta(1)./ta./threads,'-bs',threads,tb(1)./tb./threads,'-r*')
xlabel('#threads')
ylabel('efficency')
title('efficency on E5-2660 [10 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')