% Results of scaling tests for scalar product
% Oct 7, 2016
% N = 100000000


% Hardware: 143.50.47.112
%           Intel(R) Core(TM) i7-4770 CPU @ 3.40GHz   (4 cores, 8MB L2 cache)
%           32 GB memory
clear; clc; clf
threads = [1 2 4 8];

%% A)  s = sum x[i]*y[i]

ta = [0.092,  0.074, 0.074, 0.073];

%% B)  s = sum exp ( log(x[i])+log(y[i]) )

tb = [19.0, 9.5, 4.9, 2.9];

%% Plot run time
plot(threads,ta,'-bs',threads,tb,'-r*')
xlabel('#threads')
ylabel('sec.')
title('runtime on i7-4770 [4 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')


%% Plot speedup
plot(threads,ta(1)./ta,'-bs',threads,tb(1)./tb,'-r*')
xlabel('#threads')
ylabel('speedup')
title('speedup on i7-4770 [4 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')


%% Plot efficency
plot(threads,ta(1)./ta./threads,'-bs',threads,tb(1)./tb./threads,'-r*')
xlabel('#threads')
ylabel('efficency')
title('efficency on i7-4770 [4 cores]')
legend('x[i]*y[i]','exp(log(x[i])+log(y[i]))')